<template>
  <div align="left">
    <div>
      <v-layout row>
        <v-col cols="8" sm="12" md="8">
          <h4 class="pb-5">
            Transaction Summary
          </h4>
        </v-col>

        <v-col cols="4" sm="12" md="4">
          <template>
            <div align="right">
              <v-menu offset-y transition="slide-y-transition">
                <template v-slot:activator="{ on }">
                  <v-btn text v-on="on">
                    <v-icon class="mr-1">mdi-filter-variant</v-icon>
                  </v-btn>
                </template>
                <v-card>
                  <v-list>
                    <v-list-item-group>
                      <v-list-item @click="getTransaction('day')">
                        <v-list-item-title style="width:180px">
                          Day
                        </v-list-item-title>
                      </v-list-item>

                      <v-list-item @click="getTransaction('month')">
                        <v-list-item-title>
                          Month
                        </v-list-item-title>
                      </v-list-item>
                    </v-list-item-group>
                  </v-list>
                </v-card>
              </v-menu>
            </div>
          </template>
        </v-col>
      </v-layout>
    </div>
    <v-card class="mx-auto chart-widget pa-3" tile>
      <div class="chart" id="chartdiv"></div>
    </v-card>
  </div>
</template>

<script>
import * as am4core from "@amcharts/amcharts4/core";
import * as am4charts from "@amcharts/amcharts4/charts";
import am4themes_animated from "@amcharts/amcharts4/themes/animated";
am4core.useTheme(am4themes_animated);

export default {
  methods: {
    chart() {
      let self = this;
      am4core.ready(function() {
        am4core.useTheme(am4themes_animated);
        let chart = am4core.create("chartdiv", am4charts.XYChart);
        chart.data = self.result;
        let categoryAxis = chart.xAxes.push(new am4charts.CategoryAxis());
        categoryAxis.dataFields.category = "date";
        categoryAxis.renderer.grid.template.location = 0;
        categoryAxis.renderer.minGridDistance = 30;
        categoryAxis.renderer.labels.template.adapter.add("dy", function(
          dy,
          target
        ) {
          if (target.dataItem && target.dataItem.index & (2 == 2)) {
            return dy + 25;
          }
          return dy;
        });

        chart.yAxes.push(new am4charts.ValueAxis());
        let series = chart.series.push(new am4charts.ColumnSeries());
        series.dataFields.valueY = "value";
        series.dataFields.categoryX = "date";
        series.name = "Value";
        series.columns.template.tooltipText = "{categoryX}: [bold]{valueY}[/]";
        series.columns.template.fillOpacity = 0.8;

        let columnTemplate = series.columns.template;
        columnTemplate.strokeWidth = 0;
        columnTemplate.fill = "#9ae038";
        columnTemplate.strokeOpacity = 1;
      });
    },
    async getTransaction(val = null) {
      let self = this;
      let res = null;
      let sort_field = self.sort_field;
      let sort_type = self.sort_type;
      let page = self.page;
      let per_page = self.per_page;
      let description = self.description;
      if (val) {
        self.type = val;
      }

      let url =
        self.base_url +
        "api/v1/finances?title=" +
        description +
        "&sort_field=" +
        sort_field +
        "&sort_type=" +
        sort_type +
        "&page=" +
        page +
        "&per_page=" +
        per_page;

      try {
        res = await self.axios.get(url, {
          headers: {
            Authorization: "Bearer " + self.token,
            "Content-Type": "application/json;charset=UTF-8",
          },
        });
      } catch (err) {
        alert(JSON.stringify(err.response.data));
      } finally {
        self.result = this.getArr(res.data["data"], self.type);
        this.chart();
        console(res);
      }
    },
    getArr(data, type) {
      let values = [];
      let date = null;
      for (let i = 0; i < parseInt(data.length); i++) {
        if (type == "day") {
          date = data[i].created_at.substring(0, 10);
        } else if (type == "month") {
          var d = new Date(data[i].created_at).getMonth();
          date = this.month(d);
        }
        let value = data[i].debit_amount;
        values.push({ date: date, value: value });
      }

      let result = values
        .reduce(
          function(res, obj) {
            if (!(obj.date in res)) res.__array.push((res[obj.date] = obj));
            else {
              res[obj.date].value += obj.value;
            }
            return res;
          },
          { __array: [] }
        )
        .__array.sort(function(a, b) {
          return a.date - b.date;
        });
      return result;
    },
    month(index) {
      const monthNames = [
        "January",
        "February",
        "March",
        "April",
        "May",
        "June",
        "July",
        "August",
        "September",
        "October",
        "November",
        "December",
      ];
      return monthNames[index];
    },
  },
  mounted() {
    setTimeout(() => {
      this.getTransaction();
    }, 100);
  },
  data() {
    return {
      name: "Chart",
      sort_field: "created_at",
      sort_type: 1,
      page: 0,
      per_page: 100,
      description: "",
      type: "day",
      token: localStorage.getItem("token")
    };
  },
};
</script>
